SystemOrganization addCategory: #Bundleview!

Slider subclass: #InterpolationSlider
	instanceVariableNames: 'gui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 12/28/2012 15:48'!
gui
	"Answer the value of gui"

	^ gui! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 12/28/2012 15:48'!
gui: anObject
	"Set the value of gui"

	gui := anObject! !

!InterpolationSlider methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 16:00'!
mouseUpInSlider: event

	super mouseUpInSlider: event.
	"change view"
	self gui mainWindow relationOptions t: self value.
	self gui mainWindow rebuildTree.! !

!InterpolationSlider methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 16:15'!
value: newValue
	super value: newValue.
	self gui sliderValueTextMorph ifNotNil: [self gui sliderValueTextMorph contents: 't: ', (self value roundDownTo: 0.01)].! !

Object subclass: #BSpline
	instanceVariableNames: 'tesselatedPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:31'!
addTesselatedPoint: aPoint

	tesselatedPoints add: aPoint.! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:24'!
calculateBSpline: aPointList
	
	| skm1 cpim1 cpi cpip1 sk line rkm1 lk |
	(aPointList size < 4) ifTrue: [^self].
	self addTesselatedPoint: (aPointList at: 1).
	
	skm1 := aPointList at: 1.
	cpim1 := skm1.
	cpi := aPointList at: 2.
	
	2 to: (aPointList size - 2) do: [ :i | | pointsForCurve |
		pointsForCurve := OrderedCollection new.
		(i = (aPointList size - 2))
			ifTrue: [sk := cpi.]
			ifFalse: [cpip1 := aPointList at: (i + 1).
				sk := ((cpim1 + (4 * cpi) + cpip1)/6).].
		line := cpi - cpim1.
		rkm1 := cpim1 + ((line * 1)/3).
		lk := cpim1 + ((line *2)/3).
		pointsForCurve add: skm1.
		pointsForCurve add: rkm1.
		pointsForCurve add: lk.
		pointsForCurve add: sk.
		self calculateBezier: pointsForCurve.
		skm1 := sk.
		cpim1 := cpi.
		cpi := cpip1.].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:45'!
calculateCubicBezier: aPointList
	"comment stating purpose of message"

	| bernstein0 bernstein1 bernstein2 bernstein3 calculatedPoint step stepsize t|
	stepsize := 10.
	(aPointList size = 4) ifTrue: [
		step := 1 / (stepsize - 1).
		1 to: stepsize do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t) * (1 - t).
			bernstein1 := 3 * t * (1 - t) * (1 - t).
			bernstein2 := 3 * t * t * (1 - t).
			bernstein3 := t * t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 1) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein2).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein3).
			"self halt."
			self addTesselatedPoint: calculatedPoint.
		]].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:44'!
calculateQuadraticBezier: aPointList

	| bernstein0 bernstein1 bernstein2 calculatedPoint step amountOfSteps t|
	amountOfSteps := 10.
	self addTesselatedPoint: (aPointList at: 1).
	(aPointList size = 3) ifTrue: [
		step := 1 / (amountOfSteps - 1).
		2 to: amountOfSteps do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t).
			bernstein1 := 2 * t * (1 - t).
			bernstein2 := t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein2).
			self addTesselatedPoint: calculatedPoint.
		]].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/21/2012 17:37'!
drawALineFrom: aPoint To: anotherPoint
	"drawing a circle."
	| morph |
	morph := LineMorph from: aPoint to: anotherPoint color: Color black width: 2.
	morph openInWorld.! !

!BSpline methodsFor: 'initialize' stamp: 'CR 10/23/2012 14:33'!
initialize: aPointList
	"calculates the tesselatedPoints from the given control points"

	tesselatedPoints := OrderedCollection new.
	(aPointList size = 3) ifTrue: [self calculateQuadraticBezier: aPointList.] ifFalse: [Transcript show: 'calculation of BSpline'] .
! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:11'!
render

	ShapeRenderer drawPolyLine: self tesselatedPoints.! !

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:27'!
tesselatedPoints
	"Answer the value of tesselatedPoints"

	^ tesselatedPoints! !

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:27'!
tesselatedPoints: anObject
	"Set the value of tesselatedPoints"

	tesselatedPoints := anObject! !

Object subclass: #ClickState
	instanceVariableNames: 'mainWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

ClickState subclass: #AddNodeClickState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!AddNodeClickState methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:26'!
handleClick: aNodeMorph
	aNodeMorph addChildNode.! !

ClickState subclass: #AddRelationClickState
	instanceVariableNames: 'sourceNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!AddRelationClickState methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 16:10'!
handleClick: aNodeMorph
	self sourceNode ifNil: [self sourceNode: aNodeMorph node]
	 ifNotNil: [ | relation notAllowedConnection |
		notAllowedConnection := false.
		notAllowedConnection := notAllowedConnection | (sourceNode hasAncestor: aNodeMorph node).
		notAllowedConnection := notAllowedConnection | (aNodeMorph node hasAncestor: sourceNode).
		notAllowedConnection := notAllowedConnection | (sourceNode == aNodeMorph node).
		notAllowedConnection ifFalse: [
			relation := Relation new.
			relation setSource: self sourceNode andDestination: aNodeMorph node.
			relation relationOptions: self mainWindow relationOptions.
			aNodeMorph updateTree.
		].
		self sourceNode: nil.
	].! !

!AddRelationClickState methodsFor: 'accessing' stamp: 'CR 12/26/2012 14:18'!
sourceNode
	"Answer the value of sourceNode"

	^ sourceNode! !

!AddRelationClickState methodsFor: 'accessing' stamp: 'CR 12/26/2012 14:18'!
sourceNode: anObject
	"Set the value of sourceNode"

	sourceNode := anObject! !

!ClickState methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:23'!
handleClick: aNodeMorph
	 ^ self subclassResponsibility.! !

!ClickState methodsFor: 'accessing' stamp: 'CR 12/28/2012 12:08'!
mainWindow
	"Answer the value of mainWindow"

	^ mainWindow! !

!ClickState methodsFor: 'accessing' stamp: 'CR 12/28/2012 12:08'!
mainWindow: anObject
	"Set the value of mainWindow"

	mainWindow := anObject! !

ClickState subclass: #DefaultClickState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!DefaultClickState methodsFor: 'as yet unclassified' stamp: 'CR 12/29/2012 13:58'!
handleClick: aNodeMorph
	"this clickstate should do nothing"
	^self! !

Object subclass: #FirstClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 14:36'!
calculateLineWithP1: p1 p2: p2 p3: p3 p4: p4 div: divisions
	""
	| spline a0 a1 a2 a3 b0 b1 b2 b3 t |
	a0 := ((-1 * (p1 x)) + (p2 x * 3) - (3 * (p3 x)) + (p4 x)) / 6.
	a1 := ((3 * (p1 x)) - (6 * (p2 x)) + (3 * (p3 x))) / 6.
	a2 := ((-3 * (p1 x)) + (3 * (p3 x))) / 6.
	a3 := ((p1 x) + (4 * (p2 x)) + (p3 x)) / 6.
	b0 := ((-1 * (p1 y)) + (3 * (p2 y)) - (3 * (p3 y)) + (p4 y)) / 6.
	b1 := ((3 * (p1 y)) - (6 * (p2 y)) + (3 * (p3 y))) / 6.
	b2 := ((-3 * (p1 y)) + (3 * (p3 y))) / 6.
	b3 := ((p1 y) + (4 * (p2 y)) + (p3 y)) / 6.
	spline := OrderedCollection with: a3@b3.
	1 to: (divisions) do: [:i | 
		t := i / divisions.
		spline add:
			(a3 + (t * (a2 + (t * (a1 + (t * a0))))))
			@
			(b3 + (t * (b2 + (t * (b1 + (t * b0)))))).	
	].
	^spline.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/18/2012 17:03'!
countBackwards: x
	"counts a given number backwards till zero"
	| temp |
	temp := x.
	[temp > 0] whileTrue: [
		temp := temp - 1.
		Transcript show: temp
	].! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:00'!
drawACircleAt: aPoint
	"drawing a circle."
	| morph size |
	size := 20.
	morph := CircleMorph new.
	morph bounds: (Rectangle origin: (aPoint - ((size@size)/2)) extent: (size@size)).
	morph color: Color random.
	"morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen."
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:24'!
drawALineFrom: aPoint To: anotherPoint
	"drawing a circle."
	| morph |
	morph := LineMorph from: aPoint to: anotherPoint color: Color black width: 2.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 13:30'!
drawAPolyLine
	"showcase for drawing a polygon line."
	| morph |
	morph := PolygonMorph new.
	morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 14:19'!
drawBSpline: hullPoints
	"showcase for drawing a bSpline using Matrix calculation."
	| morph bSplineMorph spline |
	morph := PolygonMorph new.
	morph setVertices: hullPoints.
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 2.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen.
	morph openInWorld.
	
	spline := OrderedCollection new.
	-2 to: (hullPoints size) do: [ :i |
	spline addAllLast: (self calculateLineWithP1: 
		(hullPoints at: ((i max: 1) min: (hullPoints size)))
		p2: (hullPoints at: (((i + 1) max: 1) min: (hullPoints size)))
		p3: (hullPoints at: (((i + 2) max: 1) min: (hullPoints size)))
		p4: (hullPoints at: (((i + 3) max: 1) min: (hullPoints size))) 
		div: 10).		
	].

	bSplineMorph := PolygonMorph new.
	bSplineMorph setVertices: spline.
	bSplineMorph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	bSplineMorph borderWidth: 2.
	bSplineMorph borderColor:  (Color h: 10 s: 1.0 v: 1.0 alpha: 1.0).
	bSplineMorph makeOpen.
	bSplineMorph openInWorld.
	
	! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/17/2012 15:57'!
firstMethod
	^self.! !

Object subclass: #GUI
	instanceVariableNames: 'systemWindow mainWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!GUI methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 13:00'!
initializeButtonWithAction: aBlock
	| aButton |
	aButton := PluggableButtonMorphPlus
		on: aBlock
		getState: nil
		action: #value.
	^aButton.! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
mainWindow
	"Answer the value of mainWindow"

	^ mainWindow! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
mainWindow: anObject
	"Set the value of mainWindow"

	mainWindow := anObject! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
systemWindow
	"Answer the value of systemWindow"

	^ systemWindow! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
systemWindow: anObject
	"Set the value of systemWindow"

	systemWindow := anObject! !

GUI subclass: #MainGUI
	instanceVariableNames: 'sliderValueTextMorph cancelButton nextStepButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!MainGUI methodsFor: 'drawing' stamp: 'CR 12/26/2012 12:59'!
addMorphToMainWindow: aMorph
	"add Morph to the mainWindow"
	"if the position is outside of the mainWindow it is set to the upper left corner"
	(((((aMorph position) x) < ((self mainWindow upperLeftPointOfMainWindow) x) or:
	((aMorph position) y) < ((self mainWindow upperLeftPointOfMainWindow) y)) or:
	((aMorph position) x) > ((self mainWindow lowerRightPointOfMainWindow) x)) or:
	((aMorph position) y) > ((self mainWindow lowerRightPointOfMainWindow) y)) ifTrue: [
		"the morph is left or above the mainWindow"
		aMorph position: self mainWindow upperLeftPointOfMainWindow.].
	self mainWindow addMorph: aMorph.! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/28/2012 16:25'!
buttonActionCreateExampleTree1
	^[self mainWindow removeAllMorphs.
		self mainWindow rootNode: TreeBuilder buildTestTree.
		self mainWindow rebuildTree.]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 19:34'!
buttonActionCreateExampleTree2
	^[self mainWindow removeAllMorphs.
		self mainWindow rootNode: TreeBuilder buildLargeTree.
		self mainWindow rebuildTree]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 19:56'!
buttonActionCreateRootNode
	^[ | rootNode |
		self mainWindow removeAllMorphs.
		rootNode := Node new.
		self mainWindow rootNode: rootNode.
		self mainWindow rebuildTree.]! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:13'!
buttonActionInterpolateControlPoints
	^[
		self mainWindow relationOptions interpolateControlPoints ifTrue: [
			self mainWindow relationOptions interpolateControlPoints: false.
		] ifFalse: [
			self mainWindow relationOptions interpolateControlPoints: true.
			self mainWindow relationOptions interpolateCurvePoints: false.			
		].
		self mainWindow rebuildTree.
	].! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:14'!
buttonActionInterpolateCurvePoints
	^[
		self mainWindow relationOptions interpolateCurvePoints ifTrue: [
			self mainWindow relationOptions interpolateCurvePoints: false.
		] ifFalse: [
			self mainWindow relationOptions interpolateCurvePoints: true.
			self mainWindow relationOptions interpolateControlPoints: false.			
		].
		self mainWindow rebuildTree.
	].! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:20'!
buttonActionLCA
	^[
		self mainWindow relationOptions useLCA ifTrue: [
			self mainWindow relationOptions useLCA: false.
		] ifFalse: [
			self mainWindow relationOptions useLCA: true.
		].
		self mainWindow rebuildTree.
	].! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 20:11'!
buttonActionRadialLayout
	^[self mainWindow layoutType: 'radial'.
		self mainWindow rebuildTree]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 20:16'!
buttonActionRemoveAllTrees
	^[self mainWindow removeAllMorphs.]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 20:10'!
buttonActionRootedLayout
	^[self mainWindow layoutType: 'rooted'.
		self mainWindow rebuildTree]! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 15:05'!
buttonActionShowInterpolationOverlay
	^[
		self mainWindow relationOptions showInterpolationOverlay ifTrue: [
			self mainWindow relationOptions showInterpolationOverlay: false.
		] ifFalse: [
			self mainWindow relationOptions showInterpolationOverlay: true.
		].
		self mainWindow rebuildTree.
	]! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:55'!
buttonActionSpecialCase
	^[
		self mainWindow relationOptions checkForSpecialCase ifTrue: [
			self mainWindow relationOptions checkForSpecialCase: false.
		] ifFalse: [
			self mainWindow relationOptions checkForSpecialCase: true.
		].
		self mainWindow rebuildTree.
	]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 1/5/2013 13:08'!
buttonShowPathCalculation
	^[| pathGUI |
		pathGUI := PathGUI new.
		pathGUI mainWindow layoutType: self mainWindow layoutType.
		pathGUI mainWindow rootNode: self mainWindow rootNode.
		pathGUI mainWindow rebuildTree.]! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 12/28/2012 16:43'!
cancelButton
	"Answer the value of cancelButton"

	^ cancelButton! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 12/28/2012 16:43'!
cancelButton: anObject
	"Set the value of cancelButton"

	cancelButton := anObject! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 1/5/2013 13:02'!
initialize
	| numberOfButtonFields |
	numberOfButtonFields := 4.
	self systemWindow: PluggableSystemWindow new.
	self mainWindow: GUIMainWindow new.
	self mainWindow initializeState.
	
	self systemWindow
		label: 'Hierarchical Edge Bundles Demo';
		addMorph: mainWindow frame: (0.1@0.105 corner: 1@1).
	
	self initializeTreeModifierButtonsWithTop: 0.1 AndRight: 0.1.
	self initializeCreateNewTreeButtonsWithBottom: 0.1 AndRight: (1/numberOfButtonFields).
	self initializeLayoutButtonsWithBottom: 0.1 AndLeft: (1/numberOfButtonFields) AndRight: (2/numberOfButtonFields).
	self initializeInterpolationButtonsWithBottom: 0.1 AndLeft: (2/numberOfButtonFields) AndRight: (3/numberOfButtonFields).
	self initializeLCAButtonsWithBottom: 0.1 AndLeft: (3/numberOfButtonFields) AndRight: (4/numberOfButtonFields).
	
	self systemWindow openInWorld.
	self systemWindow bounds: (172@39 corner: 1080@622).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 20:24'!
initializeCreateNewTreeButtonsWithBottom: bottom AndRight: right
	| numberOfButtons buttonForCustomTree buttonForTree1 buttonForTree2 |
	numberOfButtons := 3.
	buttonForCustomTree := self initializeButtonWithAction: self buttonActionCreateRootNode.
	buttonForCustomTree label: 'build new tree'.
	buttonForTree1 := self initializeButtonWithAction: self buttonActionCreateExampleTree1.
	buttonForTree1 label: 'build simple tree'.
	buttonForTree2 := self initializeButtonWithAction: self buttonActionCreateExampleTree2.
	buttonForTree2 label: 'build complex tree'.
	
	self systemWindow addMorph: buttonForCustomTree frame: (0@0 corner: right@(1/numberOfButtons*bottom)).
	self systemWindow addMorph: buttonForTree1 frame: (0@(1/numberOfButtons*bottom) corner: right@(2/numberOfButtons*bottom )).
	self systemWindow addMorph: buttonForTree2 frame: (0@(2/numberOfButtons*bottom) corner: right@(3/numberOfButtons*bottom)).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 16:13'!
initializeInterpolationButtonsWithBottom: bottom AndLeft: left AndRight: right
	| numberOfButtons buttonForControlPoints buttonForCurvePoints interpolationSlider |
	numberOfButtons := 3.
	buttonForControlPoints := self initializeButtonWithAction: self buttonActionInterpolateControlPoints.
	buttonForControlPoints label: 'Interpolate Control Points'.
	buttonForCurvePoints := self initializeButtonWithAction: self buttonActionInterpolateCurvePoints.
	buttonForCurvePoints label: 'Interpolate Curve Points'.
	interpolationSlider := InterpolationSlider new.
	interpolationSlider gui: self.
	interpolationSlider value: 0.85.
	
	self systemWindow addMorph: buttonForControlPoints frame: (left@0 corner: right@(1/numberOfButtons*bottom)).
	self systemWindow addMorph: buttonForCurvePoints frame: (left@(1/numberOfButtons*bottom) corner: right@(2/numberOfButtons*bottom)).
	self systemWindow addMorph: interpolationSlider frame: ((left + ((right -left)/3))@(2/numberOfButtons*bottom) corner: right@(3/numberOfButtons*bottom)).
	self initializeTextMorphWithLabel: 't: ', interpolationSlider value WithLeft: left AndRight: (left + ((right -left)/3)) AndBottom: bottom AndTop: (2/numberOfButtons*bottom).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:02'!
initializeLCAButtonsWithBottom: bottom AndLeft: left AndRight: right
	| numberOfButtons buttonForInterpolationOverlay buttonForLCA buttonForSpecialCase |
	numberOfButtons := 3.
	buttonForInterpolationOverlay := self initializeButtonWithAction: self buttonActionShowInterpolationOverlay.
	buttonForInterpolationOverlay label: 'Show InterpolationOverlay'.
	buttonForLCA := self initializeButtonWithAction: self buttonActionLCA.
	buttonForLCA label: 'Do not use LCA'.
	buttonForSpecialCase := self initializeButtonWithAction: self buttonActionSpecialCase.
	buttonForSpecialCase label: 'Special Case for Path of Length 3'.
	
	self systemWindow addMorph: buttonForInterpolationOverlay frame: (left@0 corner: right@(1/numberOfButtons*bottom)).
	self systemWindow addMorph: buttonForLCA frame: (left@(1/numberOfButtons*bottom) corner: right@(2/numberOfButtons*bottom)).
	self systemWindow addMorph: buttonForSpecialCase frame: (left@(2/numberOfButtons*bottom) corner: right@(3/numberOfButtons*bottom)).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 20:12'!
initializeLayoutButtonsWithBottom: bottom AndLeft: left AndRight: right
	| numberOfButtons buttonForRootedTree buttonForRadialTree |
	numberOfButtons := 2.
	buttonForRootedTree := self initializeButtonWithAction: self buttonActionRootedLayout.
	buttonForRootedTree label: 'use rooted trees'.
	buttonForRadialTree := self initializeButtonWithAction: self buttonActionRadialLayout.
	buttonForRadialTree label: 'use radial trees'.
	
	self systemWindow addMorph: buttonForRootedTree frame: (left@0 corner: right@(1/numberOfButtons*bottom - 0.001)).
	self systemWindow addMorph: buttonForRadialTree frame: (left@(1/numberOfButtons*bottom + 0.001) corner: right@(2/numberOfButtons*bottom - 0.001)).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 16:18'!
initializeTextMorphWithLabel: label WithLeft: left AndRight: right AndBottom: bottom AndTop: top
	
	self sliderValueTextMorph: StringMorph new.
	self sliderValueTextMorph contents: label.
	self systemWindow addMorph: self sliderValueTextMorph frame: (left@top corner: right@bottom).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 12/29/2012 14:10'!
initializeTreeModifierButtonsWithTop: top AndRight: right
	| addNodeButton addRelationButton removeButton showPathButton|
	addNodeButton := self initializeButtonWithAction: [self mainWindow state: AddNodeClickState new].
	addNodeButton label: 'add Nodes'.
	addRelationButton := self initializeButtonWithAction: [self mainWindow state: AddRelationClickState new].
	addRelationButton label: 'add Relations'.
	removeButton := self initializeButtonWithAction: self buttonActionRemoveAllTrees.
	removeButton label: 'reset'.
	showPathButton := self initializeButtonWithAction: self buttonShowPathCalculation.
	showPathButton label: 'show Path'.
	
	self systemWindow addMorph: addNodeButton frame: (0.001@top corner: right@(top + 0.1)).
	self systemWindow addMorph: addRelationButton frame: (0.001@(top + 0.1) corner: right@(top + 0.2)).
	self systemWindow addMorph: showPathButton  frame: (0.001@(top + 0.2) corner: right@(top + 0.3)).
	self systemWindow addMorph: removeButton frame: (0.001@0.9 corner: right@1).! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 12/29/2012 13:52'!
nextStepButton
	"Answer the value of nextStepButton"

	^ nextStepButton! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 12/29/2012 13:52'!
nextStepButton: anObject
	"Set the value of nextStepButton"

	nextStepButton := anObject! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 16:34'!
prepareClickStateButtons
	| addNodeButton addRelationButton |
	addNodeButton := self initializeButtonWithAction: [self mainWindow state: AddNodeClickState new].
	addNodeButton label: 'add Nodes'.
	addRelationButton := self initializeButtonWithAction: [self mainWindow state: AddRelationClickState new].
	addRelationButton label: 'add Relations'.
	
	self mainWindow addMorph: addNodeButton atRelativePosition: 0.75@0.1 withExtend: 0.9@0.25.
	self mainWindow addMorph: addRelationButton  atRelativePosition: 0.75@0.3 withExtend: 0.9@0.45.! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 12/28/2012 15:07'!
sliderValueTextMorph
	"Answer the value of sliderValueTextMorph"

	^ sliderValueTextMorph! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 12/28/2012 15:07'!
sliderValueTextMorph: anObject
	"Set the value of sliderValueTextMorph"

	sliderValueTextMorph := anObject! !

GUI subclass: #PathGUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!PathGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 12:56'!
buttonActionStep
	^["do next step"]! !

!PathGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 13:00'!
initialize
	self systemWindow: PluggableSystemWindow new.
	self mainWindow: PathMainWindow new.
	self systemWindow
		label: 'show Path Calculation';
		addMorph: self mainWindow frame: (0@0.1 corner: 1@1).
	
	self initializeShowPathButtons: 0.1.
	self systemWindow openInWorld.
	self systemWindow bounds: (500@167 corner: 1080@622).! !

!PathGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 12:58'!
initializeShowPathButtons: bottom
	| stepButton |
	stepButton := self initializeButtonWithAction: self buttonActionStep.
	stepButton label: 'next step'.
	
	self systemWindow addMorph: stepButton frame: (0@0 corner: 1@bottom). ! !

Object subclass: #InterpolationOverlay
	instanceVariableNames: 'relation pathNodes interpolatedNodes directLineNodes pathLine interpolatedLine directLine crossLines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:22'!
abandon
	"lines"
	self directLine ifNotNil: [
		self directLine abandon.
		self directLine: nil.
	].
	self interpolatedLine ifNotNil: [
		self interpolatedLine abandon.
		self interpolatedLine: nil.
	].
	self pathLine ifNotNil: [
		self pathLine abandon.
		self pathLine: nil.
	].
	self crossLines ifNotNil: [
		self crossLines do: [ :morph |
			morph abandon.
		].
		self crossLines: nil.
	].
	"circles"
	self interpolatedNodes ifNotNil: [
		self interpolatedNodes do: [ :morph |
			morph abandon.
		].
		self interpolatedNodes: nil.
	].
	self directLineNodes ifNotNil: [
		self directLineNodes do: [ :morph |
			morph abandon.
		].
		self directLineNodes: nil.
	].
	self pathNodes ifNotNil: [
		self pathNodes do: [ :morph |
			morph abandon.
		].
		self pathNodes: nil.
	].
! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:52'!
crossLines
	"Answer the value of crossLines"

	^ crossLines! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:52'!
crossLines: anObject
	"Set the value of crossLines"

	crossLines := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLine
	"Answer the value of directLine"

	^ directLine! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLine: anObject
	"Set the value of directLine"

	directLine := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLineNodes
	"Answer the value of directLineNodes"

	^ directLineNodes! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLineNodes: anObject
	"Set the value of directLineNodes"

	directLineNodes := anObject! !

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:19'!
drawNewOn: aMorph
	| pathTempNodes tempT pathPoints interpolatedPoints directLinePoints size |
	
"		aRelation relationOptions showInterpolationOverlay ifNotNil: [
		aRelation relationOptions showInterpolationOverlay ifTrue: [
"
	self relation interpolateControlPoints ifTrue: [
		pathTempNodes := self relation source calculatePathTo: self relation destination useLCA: self relation useLCA checkForSpecialCase: self relation relationOptions checkForSpecialCase.
	] ifFalse: [
		self relation interpolateCurvePoints ifTrue: [
			pathTempNodes := self relation notInterpolatedCurvePoints.
		] ifFalse: [
			^self
		].
	].

	"extract point list"
	pathPoints := OrderedCollection new.
	pathTempNodes do: [ :node |
		pathPoints add: (node x @ node y).
	].

	interpolatedPoints := OrderedCollection new.
	interpolatedPoints := self relation interpolatePoints: pathPoints.
	tempT := self relation relationOptions t.
	self relation relationOptions t: 0.
	directLinePoints := OrderedCollection new.
	directLinePoints := self relation interpolatePoints: pathPoints.
	self relation relationOptions t: tempT.
	
	"direct Line"
	self directLine ifNil: [
		self directLine: (LineMorph
				from: (pathTempNodes first x)@(pathTempNodes first y)
				to: (pathTempNodes last x)@(pathTempNodes last y)
				color: Color darkGray
				width: 1).
		aMorph addMorph: self directLine.
	].
	self directLine
		verticesAt: 1 put: (pathTempNodes first x)@(pathTempNodes first y);
		verticesAt: 2 put: (pathTempNodes last x)@(pathTempNodes last y).
	
	"interpolatedLine"
	self interpolatedLine ifNil: [
		self interpolatedLine: PolygonMorph new.
			aMorph addMorph: self interpolatedLine.
		].
	self interpolatedLine
		setVertices: interpolatedPoints;
		makeOpen;
		borderWidth: 1;
		borderColor: Color darkGray.
	
	"pathLine"
	self pathLine ifNil: [
		self pathLine: PolygonMorph new.
			aMorph addMorph: self pathLine.
		].
	self pathLine
		setVertices: pathPoints;
		makeOpen;
		borderWidth: 1;
		borderColor: Color darkGray.
	
	"crossLines"
	self crossLines ifNil: [
		self crossLines: OrderedCollection new.
		1 to: pathTempNodes size do: [ :i |
			self crossLines add: (LineMorph new).
			aMorph addMorph: self crossLines last.
		].
	].
	1 to: pathTempNodes size do: [ :i |
		(self crossLines at: i)
			verticesAt: 1 put: ((pathPoints at: i) x)@((pathPoints at: i) y);
			verticesAt: 2 put: ((directLinePoints at: i) x)@((directLinePoints at: i) y);
			borderColor: Color darkGray;
			borderWidth: 1.
	].
	
	size := 10.
	"directLineNodes"
	self directLineNodes ifNil: [
		self directLineNodes: OrderedCollection new.
		1 to: directLinePoints size do: [ :i |
			self directLineNodes add: (CircleMorph new).
			aMorph addMorph: self directLineNodes last.
		].
	].
	1 to: directLinePoints size do: [ :i |
		(self directLineNodes at: i)
			bounds: (Rectangle
				origin: ((((directLinePoints at: i) x)@((directLinePoints at: i) y)) - (((size)@(size))/2)) 
				extent: ((size)@(size)));
			color: Color white;
			borderColor: Color darkGray;
			borderWidth: 1.
	].
		
	"interpolatedNodes"
	self interpolatedNodes ifNil: [
		self interpolatedNodes: OrderedCollection new.
		1 to: interpolatedPoints size do: [ :i |
			self interpolatedNodes add: (CircleMorph new).
			aMorph addMorph: self interpolatedNodes last.
		].
	].
	1 to: interpolatedPoints size do: [ :i |
		(self interpolatedNodes at: i)
			bounds: (Rectangle
				origin: ((((interpolatedPoints at: i) x)@((interpolatedPoints at: i) y)) - (((size)@(size))/2)) 
				extent: ((size)@(size)));
			color: Color white;
			borderColor: Color darkGray;
			borderWidth: 1.
	].
		
	"pathNodes"
	self pathNodes ifNil: [
		self pathNodes: OrderedCollection new.
		1 to: pathPoints size do: [ :i |
			self pathNodes add: (CircleMorph new).
			aMorph addMorph: self pathNodes last.
		].
	].
	1 to: pathPoints size do: [ :i |
		(self pathNodes at: i)
			bounds: (Rectangle
				origin: ((((pathPoints at: i) x)@((pathPoints at: i) y)) - (((size)@(size))/2)) 
				extent: ((size)@(size)));
			color: Color white;
			borderColor: Color darkGray;
			borderWidth: 1.
	].! !

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:24'!
drawOn: aMorph

	self abandon.
	self relation relationOptions showInterpolationOverlay ifTrue: [
		self drawNewOn: aMorph.
	].
	! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
interpolatedLine
	"Answer the value of interpolatedLine"

	^ interpolatedLine! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
interpolatedLine: anObject
	"Set the value of interpolatedLine"

	interpolatedLine := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
interpolatedNodes
	"Answer the value of interpolatedNodes"

	^ interpolatedNodes! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
interpolatedNodes: anObject
	"Set the value of interpolatedNodes"

	interpolatedNodes := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathLine
	"Answer the value of pathLine"

	^ pathLine! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathLine: anObject
	"Set the value of pathLine"

	pathLine := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathNodes
	"Answer the value of pathNodes"

	^ pathNodes! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathNodes: anObject
	"Set the value of pathNodes"

	pathNodes := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
relation
	"Answer the value of relation"

	^ relation! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
relation: anObject
	"Set the value of relation"

	relation := anObject! !

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 17:36'!
setRelation: aRelation
	self relation: aRelation.
	aRelation interpolationOverlay: self.! !

Object subclass: #Node
	instanceVariableNames: 'children parent relations weight x y size nodeRepresentation lineRepresentations label labelRepresentation transparency isHighlighted highlightedHierarchicalLines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Node commentStamp: 'CR 10/19/2012 10:33' prior: 0!
A Node is a part of a graph data structure. It knows its parent and its children as well of all relations that connect the node to an other node.

Instance Variables
	children:		<Object>
	parent:		<Object>
	relations:		<Object>

children
	- xxxxx

parent
	- xxxxx

relations
	- xxxxx
!

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:59'!
abandonAll
	"recursively dispose all morph objects for this graph"
	self children do: [ :child |
		child abandonAll.
	].
	ShapeRenderer abandonNode: self.
	ShapeRenderer abandonHierarchicalLinesFor: self.
	self relations do: [:relation | relation abandon.].
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:11'!
addChild: aChild
	children add: aChild.
	aChild parent: self.! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:29'!
addRelation: aRelation
	relations add: aRelation.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 15:40'!
calculateNumberOfLeafs
	"calculate the number of leaf nodes in this (sub-)tree."
	| numberOfLeafs |
	numberOfLeafs := 0.
	self children
		ifEmpty: [numberOfLeafs := 1]
		ifNotEmpty: [self children do: [ :child | numberOfLeafs := numberOfLeafs + child calculateNumberOfLeafs]].
	^numberOfLeafs! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 14:51'!
calculatePathTo: otherNode
	^self calculatePathTo: otherNode useLCA: true checkForSpecialCase: true.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:50'!
calculatePathTo: otherNode useLCA: includeLCA checkForSpecialCase: checkForSpecialCase
	| path myParent otherParent myList otherList |
	myParent := self.
	otherParent := otherNode.
	myList := OrderedCollection new.
	otherList := OrderedCollection new.

	"bring nodes to same depth"
	((myParent depth) > (otherParent depth)) ifTrue: [
		((myParent depth) - (otherParent depth)) timesRepeat: [
			myList add: myParent.
			myParent := myParent parent.
		].
	].
	((myParent depth) < (otherParent depth)) ifTrue: [
		((otherParent depth) - (myParent depth)) timesRepeat: [
			otherList add: otherParent .
			otherParent := otherParent parent.
		].
	].

	"go up one level of depth until parents are the same"
	[myParent ~~ otherParent]
	whileTrue: 
	[
		myList add: myParent.
		otherList add: otherParent .
		myParent := myParent parent.
		otherParent := otherParent parent.
	] 
	.
	(includeLCA) ifTrue: [
		myList add: myParent.
	] ifFalse: [
		(checkForSpecialCase & ((myList size + otherList size) < 3)) ifTrue: [
		myList add: myParent.
		].
	].
	
	path := myList.
	path addAllLast: (otherList reversed).
	^path.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 09:57'!
calculateRadialTreeLayoutAtPoint: rootPoint nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance
	"."
	self 
		calculateRadialTreeLayoutAtPoint: rootPoint 
		startAngle: 0 
		endAngle: 2 * 3.1415
		nodeSize: nodeSize 
		nodePadding: nodePadding 
		layerDistance: layerDistance 
		totalNumberOfLeafs: (self calculateNumberOfLeafs).
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 10:01'!
calculateRadialTreeLayoutAtPoint: rootPoint startAngle: startAngle endAngle: endAngle nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance totalNumberOfLeafs: totalNumberOfLeafs
	"."
	| abc angle anglePerLeaf childStartAngle childEndAngle |
	angle := (startAngle + endAngle) / 2.
	self x: angle sin * (self depth - 1) * layerDistance + rootPoint x.
	self y: angle cos * (self depth - 1) * layerDistance + rootPoint y.
	self size: nodeSize.
	
	anglePerLeaf := (endAngle - startAngle) / totalNumberOfLeafs.
	childStartAngle := startAngle.
	self children do: [ :child | 
		abc := 0.
		childEndAngle := childStartAngle + (anglePerLeaf * (child calculateNumberOfLeafs)).
		child 
			calculateRadialTreeLayoutAtPoint: rootPoint 
			startAngle: childStartAngle
			endAngle: childEndAngle
			nodeSize: nodeSize
			nodePadding: nodePadding 
			layerDistance: layerDistance 
			totalNumberOfLeafs: (child calculateNumberOfLeafs).
		childStartAngle := childEndAngle.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 15:46'!
calculateRootedTreeLayoutAtPoint: rootPoint nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance
	"."
	| childLeft length childX childY |
	self x: rootPoint x.
	self y: rootPoint y.
	self size: nodeSize.

	length := (nodeSize + nodePadding) * self calculateNumberOfLeafs.
	childLeft := rootPoint x - (length / 2).
	
	childX := childLeft.
	childY := rootPoint y + layerDistance.
	
	self children do: [ :child | 
		childX := childX + ((nodeSize + nodePadding) * child calculateNumberOfLeafs /2).
		child calculateRootedTreeLayoutAtPoint: (childX@childY) 
			nodeSize: nodeSize 
			nodePadding: nodePadding 
			layerDistance: layerDistance.
		childX := childX + ((nodeSize + nodePadding) * child calculateNumberOfLeafs /2).
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/21/2012 16:12'!
calculateWeight
	"calculate the weight of this node depending on the weight of the children"

	| calculatedWeight |
	calculatedWeight := 0.
	self children
		ifEmpty: [calculatedWeight := self weight]
		ifNotEmpty: [self children do: [ :child | calculatedWeight := calculatedWeight + child calculateWeight]].
	self weight: calculatedWeight.
	^calculatedWeight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:24'!
children
	^children! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
children: anObject
	"Set the value of children"

	children := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:37'!
depth
	self isRoot
		ifTrue: [^1]
		ifFalse: [^1 + parent depth].! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 11/30/2012 19:27'!
do: aBlock
	"recursively applies the given block"
	aBlock value: self.
	self children do: [ :child |
		child do: aBlock.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 14:05'!
drawHierarchyLinesOn: aMorph
	"recursively draws all parent-child-relations in its subtree as circles"
	self children do: [ :child |
		child drawHierarchyLinesOn: aMorph.
	].
	ShapeRenderer drawHierarchyLinesFor: self On: aMorph.
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 13:21'!
drawNodesOn: aMorph
	"recursively draws all nodes in its subtree as circles"
	self children do: [ :child |
		child drawNodesOn: aMorph.
	].	
	ShapeRenderer drawNode: self On: aMorph.
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 14:46'!
drawRelationsOn: aMorph
	"recursively draws all relations in its subtree as circles"
	self relations do: [ :relation |
		relation
			calculateCurveForPath: (self calculatePathTo: relation destination useLCA: relation useLCA checkForSpecialCase: relation relationOptions checkForSpecialCase);
			drawOn: aMorph.
	].
	self children do: [ :child |
		child drawRelationsOn: aMorph.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 11/18/2012 14:37'!
drawWithLinesOn: aMorph
	"."
	self drawRelationsOn: aMorph;
		drawHierarchyLinesOn: aMorph;
		drawNodesOn: aMorph.
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:59'!
getMaxDepth
	"get depth of the whole (sub-)tree."
	| maxDepthOfChildren |
	maxDepthOfChildren := children inject: 0 into: [:prev :child | (prev > child getMaxDepth)
		ifTrue: [prev]
		ifFalse: [child getMaxDepth]].
	^ maxDepthOfChildren + 1.
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 16:00'!
hasAncestor: aNode
	self parent ifNil: [
		^false.
	].

	(self parent == aNode) ifTrue: [
		^true.
	] ifFalse: [
		^self parent hasAncestor: aNode.
	].
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:45'!
highlightHierarchyLineTo: aNode
	"highlights the line between self and the parent node"
	(self children includes: aNode) ifTrue: [
		self highlightedHierarchicalLines add: aNode.
	] ifFalse: [
		aNode highlightHierarchyLineTo: self.
	].
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 14:44'!
highlightPathTo: aNode
	"highlights all nodes and hierarchical relations to aNode"
	| nodePath |
	nodePath := self calculatePathTo: aNode.
	2 to: (nodePath size) do: [ :i | (nodePath at: (i-1)) highlightHierarchyLineTo: (nodePath at: i). ].
	nodePath do: [:node | node isHighlighted: true. ].! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
highlightedHierarchicalLines
	"Answer the value of highlightedHierarchicalLines"

	^ highlightedHierarchicalLines! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
highlightedHierarchicalLines: anObject
	"Set the value of highlightedHierarchicalLines"

	highlightedHierarchicalLines := anObject! !

!Node methodsFor: 'initializing' stamp: 'SL 12/24/2012 15:27'!
initialize
	super initialize.
	weight := 1.
	isHighlighted := false.
	children := OrderedCollection new.
	relations := OrderedCollection new.
	lineRepresentations := Dictionary new.
	highlightedHierarchicalLines := OrderedCollection new.! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
isHighlighted
	"Answer the value of isHighlighted"

	^ isHighlighted! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
isHighlighted: anObject
	"Set the value of isHighlighted"

	isHighlighted := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:26'!
isLeaf
	^ children isEmpty.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:07'!
isRoot
	^ parent isNil.! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
label
	"Answer the value of label"

	^ label! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
label: anObject
	"Set the value of label"

	label := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
labelRepresentation
	"Answer the value of labelRepresentation"

	^ labelRepresentation! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
labelRepresentation: anObject
	"Set the value of labelRepresentation"

	labelRepresentation := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:36'!
lineRepresentations
	"Answer the value of lineRepresentations"

	^ lineRepresentations! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:36'!
lineRepresentations: anObject
	"Set the value of lineRepresentations"

	lineRepresentations := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 11/9/2012 11:40'!
nodeRepresentation
	"Answer the value of nodeRepresentation"

	^ nodeRepresentation! !

!Node methodsFor: 'accessing' stamp: 'SL 11/9/2012 11:40'!
nodeRepresentation: anObject
	"Set the value of nodeRepresentation"

	nodeRepresentation := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:13'!
parent
	"Answer the value of parent"

	^ parent! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:14'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:30'!
relations
	^relations! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
relations: anObject
	"Set the value of relations"

	relations := anObject! !

!Node methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 11:56'!
setTransparency: aTransparency
	"recursively set the given transparency for whole (sub-)tree"
	self do: [ :node |
		node transparency: aTransparency.
		node children do: [ :relation | relation relationOptions transparency: aTransparency ].
	].
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:28'!
size
	^size! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:27'!
size: anObject
	"Set the value of size"

	size := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 12/1/2012 14:54'!
transparency
	"Answer the value of transparency"

	^ transparency! !

!Node methodsFor: 'accessing' stamp: 'SL 12/1/2012 14:54'!
transparency: anObject
	"Set the value of transparency"

	transparency := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight
	^weight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight: aNumber
	weight := aNumber.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
x
	"Answer the value of x"

	^ x! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
x: anObject
	"Set the value of x"

	x := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
y
	"Answer the value of y"

	^ y! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
y: anObject
	"Set the value of y"

	y := anObject! !

Object subclass: #Relation
	instanceVariableNames: 'source destination tesselatedPoints t useLCA interpolateControlPoints interpolateCurvePoints representation transparency interpolationOverlay notInterpolatedCurvePoints relationOptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Relation commentStamp: 'CR 10/19/2012 10:34' prior: 0!
A Relation describes an usally non hierarchical connection between two nodes.

Instance Variables
	destination:		<Object>
	source:		<Object>

destination
	- xxxxx

source
	- xxxxx
!

!Relation methodsFor: 'drawing' stamp: 'SL 12/25/2012 13:50'!
abandon
	ShapeRenderer abandonRelation: self.! !

!Relation methodsFor: 'drawing' stamp: 'CR 10/23/2012 15:24'!
calculateBSpline: hullPoints
	"showcase for drawing a bSpline using Matrix calculation."
	
	self tesselatedPoints: OrderedCollection new.
	-2 to: (hullPoints size) do: [ :i |
	self tesselatedPoints addAllLast: (self calculateLineWithP1: 
		(hullPoints at: ((i max: 1) min: (hullPoints size)))
		p2: (hullPoints at: (((i + 1) max: 1) min: (hullPoints size)))
		p3: (hullPoints at: (((i + 2) max: 1) min: (hullPoints size)))
		p4: (hullPoints at: (((i + 3) max: 1) min: (hullPoints size))) 
		div: 10).		
	].! !

!Relation methodsFor: 'drawing' stamp: 'CR 12/28/2012 11:28'!
calculateCurve: aPointList
	"calculates the tesselatedPoints from the given control points"
	| interpolatedControlPoints |
	tesselatedPoints := OrderedCollection new.
	(self interpolateControlPoints) 
		ifTrue: [	interpolatedControlPoints := (self interpolatePoints: aPointList).]
		ifFalse: [interpolatedControlPoints := aPointList.].
	(interpolatedControlPoints size = 3)
		ifTrue: [self calculateQuadraticBezier: interpolatedControlPoints.]
		ifFalse: [self calculateBSpline: interpolatedControlPoints].
	self notInterpolatedCurvePoints: self tesselatedPoints.
	(self interpolateCurvePoints)
		ifTrue: [self tesselatedPoints: (self interpolatePoints: (self tesselatedPoints))].! !

!Relation methodsFor: 'drawing' stamp: 'SL 10/23/2012 16:33'!
calculateCurveForPath: aNodeList
	| pointList |
	"extracts points from given list of nodes"
	pointList := OrderedCollection new.
	aNodeList do: [ :node | 
		pointList add: (node x)@(node y).
	].
	self calculateCurve: pointList.
	^self.
! !

!Relation methodsFor: 'drawing' stamp: 'CR 10/23/2012 15:19'!
calculateLineWithP1: p1 p2: p2 p3: p3 p4: p4 div: divisions
	"matrix magic to compute bspline"
	| spline a0 a1 a2 a3 b0 b1 b2 b3 t |
	a0 := ((p1 x * -1) + (p2 x * 3) - (3 * (p3 x)) + (p4 x)) / 6.
	a1 := ((3 * (p1 x)) - (6 * (p2 x)) + (3 * (p3 x))) / 6.
	a2 := ((-3 * (p1 x)) + (3 * (p3 x))) / 6.
	a3 := ((p1 x) + (4 * (p2 x)) + (p3 x)) / 6.
	b0 := ((-1 * (p1 y)) + (3 * (p2 y)) - (3 * (p3 y)) + (p4 y)) / 6.
	b1 := ((3 * (p1 y)) - (6 * (p2 y)) + (3 * (p3 y))) / 6.
	b2 := ((-3 * (p1 y)) + (3 * (p3 y))) / 6.
	b3 := ((p1 y) + (4 * (p2 y)) + (p3 y)) / 6.
	spline := OrderedCollection with: a3@b3.
	1 to: (divisions) do: [:i | 
		t := i / divisions.
		spline add:
			(a3 + (t * (a2 + (t * (a1 + (t * a0))))))
			@
			(b3 + (t * (b2 + (t * (b1 + (t * b0)))))).	
	].
	^spline.! !

!Relation methodsFor: 'drawing' stamp: 'SL 10/24/2012 10:42'!
calculateQuadraticBezier: aPointList

	| bernstein0 bernstein1 bernstein2 calculatedPoint step amountOfSteps t|
	amountOfSteps := 10.
	self tesselatedPoints add: (aPointList at: 1).
	(aPointList size = 3) ifTrue: [
		step := 1 / (amountOfSteps - 1).
		2 to: (amountOfSteps - 1) do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t).
			bernstein1 := 2 * t * (1 - t).
			bernstein2 := t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein2).
			self tesselatedPoints add: calculatedPoint.
		]].! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
destination
	"Answer the value of destination"

	^ destination! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
destination: anObject
	"Set the value of destination"

	destination := anObject! !

!Relation methodsFor: 'drawing' stamp: 'SL 12/24/2012 14:54'!
drawOn: aMorph
	ShapeRenderer drawRelation: self On: aMorph.
! !

!Relation methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 11:21'!
initialize
	super initialize.! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:12'!
interpolateControlPoints
	"Answer the value of interpolateControlPoints"

	^ self relationOptions interpolateControlPoints! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:12'!
interpolateCurvePoints
	"Answer the value of interpolateCurvePoints"

	^ self relationOptions interpolateCurvePoints! !

!Relation methodsFor: 'drawing' stamp: 'CR 12/28/2012 11:24'!
interpolatePoints: aPointList
	"interpolate given point list"
	| interpolatedList first last t |
	t := self relationOptions t.
	first := aPointList first.
	last := aPointList last.
	interpolatedList := OrderedCollection with: first.
	2 to: (aPointList size - 1) do: [ :i |
		interpolatedList add:
			(((aPointList at: i) * t) + 
			((1 - t) * (first + (((i-1) / (aPointList size - 1)) * (last - first))))).
	].
	interpolatedList add: last.
	^interpolatedList.! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:36'!
interpolationOverlay
	"Answer the value of interpolationOverlay"

	^ interpolationOverlay! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:36'!
interpolationOverlay: anObject
	"Set the value of interpolationOverlay"

	interpolationOverlay := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/26/2012 17:48'!
notInterpolatedCurvePoints
	"Answer the value of notInterpolatedCurvePoints"

	^ notInterpolatedCurvePoints! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/26/2012 17:48'!
notInterpolatedCurvePoints: anObject
	"Set the value of notInterpolatedCurvePoints"

	notInterpolatedCurvePoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:20'!
relationOptions
	"Answer the value of relationOptions"
	relationOptions ifNil: [
		self relationOptions: RelationOptions new.
	].
	^ relationOptions! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:02'!
relationOptions: anObject
	"Set the value of relationOptions"

	relationOptions := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
representation
	"Answer the value of representation"

	^ representation! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
representation: anObject
	"Set the value of representation"

	representation := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/23/2012 15:47'!
setSource: sourceNode andDestination: destinationNode
	sourceNode addRelation: self.
	source := sourceNode.
	destination := destinationNode.
	^self.! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
source
	"Answer the value of source"

	^ source! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
source: anObject
	"Set the value of source"

	source := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:29'!
t
	"Answer the value of interpolateControlPoints"

	^ self relationOptions t.! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/23/2012 15:02'!
tesselatedPoints
	"Answer the value of tesselatedPoints"

	^ tesselatedPoints! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/23/2012 15:02'!
tesselatedPoints: anObject
	"Set the value of tesselatedPoints"

	tesselatedPoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:11'!
transparency
	"Answer the value of transparency"

	^ self relationOptions transparency.! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:11'!
useLCA
	"Answer the value of useLCA"

	^ self relationOptions useLCA.! !

Object subclass: #RelationOptions
	instanceVariableNames: 't useLCA checkForSpecialCase interpolateControlPoints interpolateCurvePoints transparency showInterpolationOverlay borderColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:58'!
borderColor
	"Answer the value of borderColor"

	^ borderColor! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:58'!
borderColor: anObject
	"Set the value of borderColor"

	borderColor := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 12/28/2012 14:29'!
checkForSpecialCase
	"Answer the value of checkForSpecialCase"

	^ checkForSpecialCase! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 12/28/2012 14:29'!
checkForSpecialCase: anObject
	"Set the value of checkForSpecialCase"

	checkForSpecialCase := anObject! !

!RelationOptions methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:00'!
initialize
	super initialize.
	self
		t: 0.85;
		useLCA: true;
		checkForSpecialCase: false;
		interpolateCurvePoints: false;
		interpolateControlPoints: true;
		showInterpolationOverlay: false;
		transparency: 0.8;
		borderColor: (Color h: 10 s: 1.0 v: 1.0 alpha: self transparency).
! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateControlPoints
	"Answer the value of interpolateControlPoints"

	^ interpolateControlPoints! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateControlPoints: anObject
	"Set the value of interpolateControlPoints"

	interpolateControlPoints := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateCurvePoints
	"Answer the value of interpolateCurvePoints"

	^ interpolateCurvePoints! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateCurvePoints: anObject
	"Set the value of interpolateCurvePoints"

	interpolateCurvePoints := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
showInterpolationOverlay
	"Answer the value of showInterpolationOverlay"

	^ showInterpolationOverlay! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
showInterpolationOverlay: anObject
	"Set the value of showInterpolationOverlay"

	showInterpolationOverlay := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
t
	"Answer the value of t"

	^ t! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
t: anObject
	"Set the value of t"

	t := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
transparency
	"Answer the value of transparency"

	^ transparency! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
transparency: anObject
	"Set the value of transparency"

	transparency := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
useLCA
	"Answer the value of useLCA"

	^ useLCA! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
useLCA: anObject
	"Set the value of useLCA"

	useLCA := anObject! !

Object subclass: #ShapeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:01'!
abandonHierarchicalLinesFor: aNode

	aNode lineRepresentations do: [ :representation |
		representation abandon.
	].
	aNode lineRepresentations removeAll.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:03'!
abandonLabelFor: aNode

	(aNode labelRepresentation) ifNotNil: [
		aNode labelRepresentation abandon.
	].

! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:03'!
abandonNode: aNode

	aNode nodeRepresentation ifNotNil: [
		aNode nodeRepresentation abandon.
		aNode nodeRepresentation: nil.
	].
	self abandonLabelFor: aNode.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 18:43'!
abandonRelation: aRelation

	aRelation representation ifNotNil: [
		aRelation representation abandon.
		aRelation representation: nil.
	].
	aRelation interpolationOverlay ifNotNil: [
		aRelation interpolationOverlay abandon.
		aRelation interpolationOverlay: nil.
	].! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/26/2012 12:56'!
drawHierarchyLinesFor: aNode On: aMorph
	"draws a simple line"
	| lineRepresentation |	
	aNode children do: [ :child |
		"create circle morph, if not already done"
		(aNode lineRepresentations includesKey: child) ifFalse: [
			aNode lineRepresentations at: child put: (LineMorph
				from: (0)@(0)
				to: (0)@(0)
				color: Color darkGray
				width: 2).
				aMorph addMorph: (aNode lineRepresentations at: child).
		].

		"update lineMorph according to node attributes"
		lineRepresentation := (aNode lineRepresentations at: child).
		lineRepresentation 
			verticesAt: 1 put: ((aNode x)@(aNode y));
			verticesAt: 2 put: ((child x)@(child y)).
		"highlighting"
		(aNode highlightedHierarchicalLines includes: child) ifTrue: [
			lineRepresentation
				borderWidth: 3;
				borderColor: (Color blue darker).
		] ifFalse: [
			lineRepresentation
				borderWidth: 2;
				borderColor: Color darkGray.
		].

	].! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:15'!
drawInterpolationOverlayFor: aRelation On: aMorph

	aRelation interpolationOverlay ifNil: [
		InterpolationOverlay new setRelation: aRelation.
	].
	aRelation interpolationOverlay drawOn: aMorph.
! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 13:54'!
drawLabelForNode: aNode
	"draws a text next to a cirlce morph"
	(aNode label) ifNotNil: [
		"create label morph, if not already done"
		aNode labelRepresentation ifNil: [
			aNode labelRepresentation: (StringMorph contents: aNode label).		
			aNode nodeRepresentation addMorph: aNode labelRepresentation.
		].
		"update label according to node attributes"
		(aNode labelRepresentation) position: (
			(aNode size / 2 + (aNode x)) @
			(aNode size / 2 + (aNode y))
		).
	].

! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/26/2012 12:50'!
drawNode: aNode On: aMorph
	"create circle morph, if not already done"
	| nodeMorph |
	aNode nodeRepresentation ifNil: [
		nodeMorph := NodeMorph new.
		nodeMorph node: aNode.
		nodeMorph gui: aMorph.
		aNode nodeRepresentation: nodeMorph.
		aMorph addMorph: (aNode nodeRepresentation).
	].
	"update circle according to node attributes"
	self updateRepresentation: aNode nodeRepresentation forNode: aNode. 

	"draw the label for the node"
	self drawLabelForNode: aNode.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/1/2012 20:28'!
drawPolyLine: aPointList

	| morph |
	morph := PolygonMorph new.
	morph setVertices: aPointList.
	morph borderWidth: 1.
	morph borderColor:  (Color h: 10 s: 1.0 v: 1.0 alpha: 1.0).
	morph makeOpen.
	^morph.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:18'!
drawRelation: aRelation On: aMorph

	self drawInterpolationOverlayFor: aRelation On: aMorph.
	
	"create polygonmorph if not already done"
	aRelation representation ifNil: [
		aRelation representation: PolygonMorph new.
		aMorph addMorph: aRelation representation.
		aRelation representation makeOpen.
	].

	"update morph according to relation attributes"
	aRelation representation setVertices: (aRelation tesselatedPoints).
	aRelation representation borderWidth: 1.
	aRelation representation borderColor: (aRelation relationOptions borderColor alpha: aRelation relationOptions transparency). 
! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:47'!
updateRepresentation: aRepresentation forNode: aNode
	"size and position"
	aRepresentation bounds: (Rectangle
		origin: (((aNode x)@(aNode y)) - (((aNode size)@(aNode size))/2)) 
		extent: ((aNode size)@(aNode size))).
	"coloring"
	aRepresentation color: Color white.
	"highlighting"
	(aNode isHighlighted) ifTrue: [
		aRepresentation borderColor: (Color blue darker).
		aRepresentation borderWidth: 3.
	] ifFalse: [
		aRepresentation borderColor: Color darkGray.
		aRepresentation borderWidth: 1.
	].
	^aRepresentation.! !

Object subclass: #TreeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 18:05'!
buildLargeTree
	"creates a simple Treestructure"
	|			 				node1 
				node11 			       			node12 
	node111    node112    node113 		node121 		node122 
										      			node1221	node1222 |
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node11 addChild: Node new.
	node111 addChild: Node new.
	node111 addChild: Node new.
	node112 addChild: Node new.
	node112 addChild: Node new.
	node113 addChild: Node new.
	node113 addChild: Node new.
	node113 addChild: Node new.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node1221 addChild: Node new.
	node1221 addChild: Node new.
	node1221 addChild: Node new.
	node122 addChild: node1222.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/24/2012 15:18'!
buildSymmetricTreeWithRelations
	"creates a simple Treestructure with relations"
	| nodeList relation |
	nodeList := OrderedCollection new.
	(1 + 4 + 16) timesRepeat: [nodeList add: Node new.].
	2 to: 5 do: [ :i |
		(nodeList at: 1) addChild: (nodeList at: i)
	].
	1 to: 4 do: [ :i |
		1 to: 4 do: [ :j |
			(nodeList at: i + 1) addChild: (nodeList at: (4 * i + j + 1))
		].
	].
	6 to: 21 do: [ :i |
		6 to: 21 do: [ :j |
			(j ~= i) ifTrue: [
				relation := Relation new
					setSource: (nodeList at: i)
					andDestination: (nodeList at: j).
			].
		].
	].
	
	^(nodeList at: 1).! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 10:06'!
buildTestTree
	"creates a simple Treestructure"
	|			 				node1 
				node11 			       			node12 
	node111       node112 		node113 		node121 		node122
										      			node1221	node1222 |
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node122 addChild: node1222.
	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:16'!
buildTreeForInterpolation
	"creates a simple Treestructure with a single relation"
	|			 				node1 
				node11 		node12 node13 node14			node15 
	node111    node112 						 			node151 		node152 
							 							node1511	node1512 

	relation112to1511
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node12 := Node new.
	node13 := Node new.
	node14 := Node new.
	node15 := Node new.
	node151 := Node new.
	node152 := Node new.
	node1511 := Node new.
	node1512 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	
	node1 addChild: node12.
	node1 addChild: node13.
	node1 addChild: node14.
	
	node1 addChild: node15.
	node15 addChild: node151.
	node15 addChild: node152.
	node151 addChild: node1511.
	node151 addChild: node1512.
	
	relation112to1511 := Relation new.
	relation112to1511 setSource: node112 andDestination: node1511.

	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:34'!
buildTreeWithOverlyingRelations
	"creates an x-shaped Treestructure with 3 relations"
	|			 				node1 
			node11 						node12 
	node111    	node112 			node121 		node122

	relation111to121
	relation111to122
	relation112to121
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node111 label: 'A'.
	node112 := Node new.
	node112 label: 'B'.
	node12 := Node new.
	node121 := Node new.
	node121 label: 'C'.
	node122 := Node new.
	node122 label: 'D'.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	
	relation111to122 := Relation new.
	relation111to122 setSource: node111 andDestination: node122.
	relation111to121 := Relation new.
	relation111to121 setSource: node111 andDestination: node121.
	relation112to121 := Relation new.
	relation112to121 setSource: node112 andDestination: node121.

	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 16:52'!
buildTreeWithRelations
	"creates a simple Treestructure with relations"
	|			 				node1 
				node11 			       			node12 
	node111    node112    node113 		node121 		node122 
										      			node1221	node1222 

	relation111to112
	relation121to1222
	relation113to1221
	relation113to1222
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node122 addChild: node1222.
	
	relation111to112 := Relation new.
	relation111to112 setSource: node111 andDestination: node112.
	relation121to1222 := Relation new.
	relation121to1222 setSource: node121 andDestination: node1222.
	relation113to1221 := Relation new.
	relation113to1221 setSource: node113 andDestination: node1221.
	relation113to1222 := Relation new.
	relation113to1222 setSource: node113 andDestination: node1222.

	relation113to1222 := Relation new.

	^node1.! !

CircleMorph subclass: #NodeMorph
	instanceVariableNames: 'node gui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:38'!
addChildNode
	self node addChild: Node new.
	self gui rebuildTree.! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
gui
	"Answer the value of gui"

	^ gui! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
gui: anObject
	"Set the value of gui"

	gui := anObject! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 19:40'!
handlesMouseDown: anEvent
	^true.! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:41'!
mouseDown: anEvent
	self gui click: self.! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
node
	"Answer the value of node"

	^ node! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
node: anObject
	"Set the value of node"

	node := anObject! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 14:38'!
updateTree
	self gui rebuildTree.! !

RectangleMorph subclass: #MainWindow
	instanceVariableNames: 'rootNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

MainWindow subclass: #GUIMainWindow
	instanceVariableNames: 'state layoutType relationOptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 16:31'!
addMorph: aMorph atRelativePosition: aPosition withExtend: aCorner
	| left right top bottom frame |
	left := self upperLeftPointOfMainWindow x + (self getWidth * aPosition x).
	top := self upperLeftPointOfMainWindow y + (self getHeight * aPosition y).
	right := self upperLeftPointOfMainWindow x + (self getWidth * aCorner x).
	bottom := self upperLeftPointOfMainWindow y + (self getHeight * aCorner y).
	aMorph bounds: (left@top corner: (right)@(bottom)).
	frame := LayoutFrame new.
	frame
		leftFraction: left;
		rightFraction: right;
		topFraction: top;
		bottomFraction: bottom.
	self addMorph: aMorph fullFrame: frame.
	! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:41'!
click: aNodeMorph
	self state handleClick: aNodeMorph.! !

!GUIMainWindow methodsFor: 'event handling' stamp: 'CR 11/18/2012 16:01'!
handlesMouseDown: anEvent
	^true.! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 11:44'!
initialize
	super initialize.
	self layoutType: 'rooted'.
	self relationOptions: RelationOptions new.! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/29/2012 13:59'!
initializeState
	self state: DefaultClickState new.
	self state mainWindow: self.! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/26/2012 19:57'!
layoutType
	"Answer the value of layoutType"

	^ layoutType! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/26/2012 19:57'!
layoutType: anObject
	"Set the value of layoutType"

	layoutType := anObject! !

!GUIMainWindow methodsFor: 'event handling' stamp: 'CR 11/18/2012 16:01'!
mouseDown: anEvent
	Transcript show: 'mouse Down'.! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 20:13'!
rebuildRadialTree
	"self removeAllMorphs."
	self rootNode calculateRadialTreeLayoutAtPoint: self getCenter nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode label: 'src'.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 19:44'!
rebuildRootedTree
	"self removeAllMorphs."
	| center |
	center := (self getCenter x)@(self getCenter y - (self getHeight/4)).
	self rootNode calculateRootedTreeLayoutAtPoint: center nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode label: 'src'.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 20:10'!
rebuildTree
	"self removeAllMorphs."
	self rootNode ifNotNil: [
		self layoutType = 'radial'
			ifTrue: [self rebuildRadialTree]
			ifFalse: [self rebuildRootedTree].].! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:39'!
relationOptions
	"Answer the value of relationOptions"

	^ relationOptions! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:39'!
relationOptions: anObject
	"Set the value of relationOptions"

	relationOptions := anObject! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/25/2012 20:00'!
state
	"Answer the value of state"

	^ state! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/28/2012 12:13'!
state: anObject
	"Set the value of state"

	state := anObject.
	self state mainWindow: self.! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:33'!
getCenter
	"calculates the center of the mainWindow and returns the values as Point"
	| x y |
	x := (self lowerRightPointOfMainWindow) x - (self upperLeftPointOfMainWindow) x.
	x := x/2.
	x := (self upperLeftPointOfMainWindow) x + x.
	y := (self lowerRightPointOfMainWindow) y - (self upperLeftPointOfMainWindow) y.
	y := y/2.
	y := (self upperLeftPointOfMainWindow) y + y.
	^x@y! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:33'!
getHeight
	^(self bounds corner y) - (self bounds origin y)! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:34'!
getWidth
	^(self bounds corner x) - (self bounds origin x)! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:34'!
lowerRightPointOfMainWindow
	^self bounds corner.! !

!MainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 13:07'!
rebuildRadialTree
	"self removeAllMorphs."
	self rootNode calculateRadialTreeLayoutAtPoint: self getCenter nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode label: 'src'.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!MainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 13:16'!
rebuildRootedTree
	"self removeAllMorphs."
	| center |
	center := (self getCenter x)@(self getCenter y - (self getHeight/4)).
	self rootNode calculateRootedTreeLayoutAtPoint: center nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode label: 'src'.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!MainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 13:08'!
rebuildTree
	"self removeAllMorphs."
	self rootNode ifNotNil: [
		self layoutType = 'radial'
			ifTrue: [self rebuildRadialTree]
			ifFalse: [self rebuildRootedTree].].! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:32'!
rootNode
	"Answer the value of rootNode"

	^ rootNode! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:32'!
rootNode: anObject
	"Set the value of rootNode"

	rootNode := anObject! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:34'!
upperLeftPointOfMainWindow
	^self bounds origin.! !

MainWindow subclass: #PathMainWindow
	instanceVariableNames: 'layoutType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!PathMainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 13:05'!
layoutType
	"Answer the value of layoutType"

	^ layoutType! !

!PathMainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 13:05'!
layoutType: anObject
	"Set the value of layoutType"

	layoutType := anObject! !
